=== imaging/components/itkimage/CMakeLists.txt ===
# itkimage component just needs to use the component_extension macro
camitk_extension(COMPONENT_EXTENSION 
                 NEEDS_ITK 
                 CEP_NAME CEP_IMAGING
                 CXX_FLAGS "-w"
                 DEFINES _SCL_SECURE_NO_WARNINGS # to remove Windows MSVC warnings
                 DESCRIPTION "This component allows CamiTK to handle basic ITK format images."
                 ENABLE_AUTO_TEST
)

# --------------------------------
# --- Specific test management ---
# --------------------------------

camitk_disable_tests(TESTS component-itkimage-level3-3
                           component-itkimage-level3-9 
                           component-itkimage-level3-10
                           component-itkimage-level3-19
                           component-itkimage-level3-20
                     REASON " Test failure due to ITK exception.
   For now disable these tests until this can be dealt with (if possible)
   For input file: biorad.pic, cthead1.lsm, BigEndian.spr, LittleEndianZ.hdr and LittleEndianZ.img.gz
   When applying action Gradient Magnitude With Smoothing, the following exception is raised:
   \"camitk-testcomponents aborted by std exception: /usr/include/ITK-4.10/itkRecursiveSeparableImageFilter.hxx:245:
   itk::ERROR: RecursiveGaussianImageFilter(0x55b3b21bc700): The number of pixels along direction 2 is less than 4. 
   This filter requires a minimum of four pixels along the dimension to be processed...\""
)

# TODO confirm diagnostic: check why BigEndianCompressed.img.gz, LittleEndianCompressed.img.gz and minimal.nii.gz does not work on Windows (maybe because of double suffix .im.gz?)
camitk_tests_requirement(TESTS component-itkimage-level3-6 
                               component-itkimage-level3-16 
                               component-itkimage-level3-28
                         REQUIRES "NOT WIN32"
                         REASON "WIN32 failure (probably) due to double suffix .im.gz or .nii.gz
   For input file: BigEndianCompressed.img.gz, LittleEndianCompressed.img.gz and minimal.nii.gz"
)

camitk_tests_requirement(TESTS component-itkimage-level3-1
                               component-itkimage-level3-4
                               component-itkimage-level3-7
                               component-itkimage-level3-11
                               component-itkimage-level3-13
                               component-itkimage-level3-15
                               component-itkimage-level3-17
                               component-itkimage-level3-21
                               component-itkimage-level3-28
                         REQUIRES "${ITK_VERSION} VERSION_EQUAL 4.13.2"
                         REASON "ITK version version 4.13.2
   The default test files are written using the currently supported version of ITK (ITK 4.13.2).
   This test will therefore fail when comparing the input to the output if another version of ITK is used."
)

# Additional test for SDK actions: this will add auto test for the given actions using the itkimage component
camitk_additional_action_test(ACTION_EXTENSIONS cropvolume imagelut imageresampling multipicking pixelcolorchanger reconstruction reorientimage showin3d volumerendering
                              TEST_FILES BigEndian.hdr BigEndian.img BigEndianCompressed1.hdr BigEndianCompressed1.img biorad.pic cthead1.lsm LittleEndian1.hdr LittleEndian1.img LittleEndianCompressed1.hdr LittleEndianCompressed1.img LittleEndianZ1.hdr mini-complex-slow1.nrrd mini-ten-nomask-slow1.nrrd mini-vector-slow1.nrrd ramp1.gipl
)
