=== debian/changelog ===
camitk (5.0.2-5) unstable; urgency=medium

  [ Andreas Tille ]
  * Build against VTK9
    Closes: #1013153
  * Standards-Version: 4.6.2
  * ignore test failures to unblock vtk7 removal

  [ Pierre Gruet ]
  * Providing the directories of needed JDK shared libs in LD_LIBRARY_PATH
    for the build-time tests

  [ Emmanuel Promayon ]
  * VTK9 compat, disabling dicom component for now

 -- Andreas Tille <tille@debian.org>  Thu, 22 Jun 2023 08:00:26 +0200

camitk (5.0.2-4) unstable; urgency=medium

  * Team upload.
  * d/control: declare compliance to standards version 4.6.1.
  * d/copyright: dedicate paragraph to the LGPL-2.1.
  * d/copyright: fix location of python_sdk/pyside_global.h.
  * d/u/lintian-overrides: override false positive error.
  * Rebuild with libinsighttoolkit5-dev, which disappeared temporarily from sid
    somehow. (Closes: #1017220)

 -- Étienne Mollier <emollier@debian.org>  Fri, 30 Sep 2022 21:09:45 +0200

camitk (5.0.2-3) unstable; urgency=medium

  * Fix FTBFS during build all and build any

 -- Emmanuel Promayon <Emmanuel.Promayon@univ-grenoble-alpes.fr>  Thu, 24 Feb 2022 14:42:18 +0100

camitk (5.0.2-2) unstable; urgency=medium

  * Add missing Copyright entry
    Closes: #1005885

 -- Andreas Tille <tille@debian.org>  Wed, 16 Feb 2022 19:21:57 +0100

camitk (5.0.2-1) unstable; urgency=medium

  [ Andreas Tille ]
  * New upstream version
  * Standards-Version: 4.6.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * (Build-)Depends libinsighttoolkit5-dev
  * Bump package version number and version numbers in Breaks fields
  * Build-Depends: libgdcm-tools
  * Adapt lintian-overrides to soversion

  [ Jose Luis Rivero ]
  * Fix compilation by removing ixx files
    Closes: #997120

  [ Emmanuel Promayon ]
  * Update d/r and fix test error to improve multiarch support
  * Update autopkgtest for new upstream version
  * Disable unnecessary generation of dot graph for apidoc
  * Add d/not-installed for not packaged binaries
  * Update metadata to add upstream repo information

 -- Andreas Tille <tille@debian.org>  Wed, 09 Feb 2022 10:40:32 +0100
